// $Date:: 2009-11-01 02:53:31 +0900#$
// $Rev: 36 $


#pragma once
#include <windows.h>
#include <emmintrin.h>
#include "avisynth.h"

typedef struct _THREAD_PARAM
{
    const __int32 * pW ;
    const int wSpan ;
    const int tSpan ;
    const int Threads ;
    const int SrcYPitch ;
    const int Height ;
    const int Width ;
    const int CacheLSpan ;
    const int CacheLOffset ;
    __int32 ** FrameCache ;
    BYTE * pSrcY ;
    int thr_num ;
    void (* SetFrame) ( _THREAD_PARAM& p , int i , int j , __m128i& s ) ;

    _THREAD_PARAM (
        const __int32 * _pW ,
        const __int32 _wSpan ,
        const __int32 _tSpan ,
        const __int32 _Threads ,
        const __int32 _SrcYPitch ,
        const __int32 _Height ,
        const __int32 _Width ,
        const __int32 _CacheLSpan ,
        const __int32 _CacheLOffset ,
        __int32 ** _FrameCache ,
        BYTE * _pSrcY = NULL ,
        int _thr_num = 0 ,
        void (* _SetFrame)( _THREAD_PARAM & , int , int , __m128i& ) = NULL
        ) :
        pW           ( _pW           ) ,
        wSpan        ( _wSpan        ) ,
        tSpan        ( _tSpan        ) ,
        Threads      ( _Threads      ) ,
        SrcYPitch    ( _SrcYPitch    ) ,
        Height       ( _Height       ) ,
        Width        ( _Width        ) ,
        CacheLSpan   ( _CacheLSpan   ) ,
        CacheLOffset ( _CacheLOffset ) ,
        FrameCache   ( _FrameCache   ) ,
        pSrcY        ( _pSrcY        ) ,
        thr_num      ( _thr_num      ) ,
        SetFrame     ( _SetFrame     )
    {
    }
} THREAD_PARAM ;

//==============================================================================
// PNLM
//==============================================================================
class PNLM : public GenericVideoFilter
{
protected:
    unsigned int Height ;
    unsigned int Width ;
    const int Strength ;
    const int wSpan ;
    const int tSpan ;
    const int Threads ;
    __int32 * pW ;
    __int32 ** FrameCache ;
    int PreFrameNum ;
    int SrcYPitch ;
    int CacheLSpan ;
    int CacheLOffset ;
    DWORD (WINAPI* ThreadFunc) ( LPVOID ) ;
    void (* SetCacheFrame) ( int cache_idx , int frame_num , IScriptEnvironment* env , PClip child , THREAD_PARAM& p ) ;
    void (* SetFrame) ( THREAD_PARAM& p , int i , int j , __m128i& s ) ;

public:
	PNLM (PClip _child, int strength, int wspan, int tspan, int threads, int opt , IScriptEnvironment* env);
	~PNLM ();
    PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) ;
};
