// $Date:: 2010-02-06 15:52:49 +0900#$
// $Rev: 11 $


#pragma once
#include <windows.h>
#include <emmintrin.h>
#include "avisynth.h"

typedef struct _THREAD_PARAM2
{
    const unsigned __int8 * pW ;
    const int wSpan ;
    const int tSpan ;
    const int SelfWeight ;
    const int AngleWeight ;
    const int Threads ;
    const int SrcYPitch ;
    const int Height ;
    const int Width ;
    const int CacheLSpan ;
    const int CacheLOffset ;
    const int IsYV12 ;
    __int16 ** Y_FrameCache ;
    __int16 ** V_FrameCache ;
    __int16 ** H_FrameCache ;
    __int16 * AvgWork ;
    BYTE * pSrcY ;
    int thr_num ;
    void (* SetFrame) ( __m128i& sumY ,  __m128i& sumC , __m128i * d ) ;

    _THREAD_PARAM2 (
        const unsigned __int8 * _pW ,
        const int _wSpan ,
        const int _tSpan ,
        const int _SelfWeight ,
        const int _AngleWeight ,
        const int _Threads ,
        const int _SrcYPitch ,
        const int _Height ,
        const int _Width ,
        const int _CacheLSpan ,
        const int _CacheLOffset ,
        const int _IsYV12 ,
        __int16 ** _Y_FrameCache ,
        __int16 ** _V_FrameCache ,
        __int16 ** _H_FrameCache ,
        __int16 * _AvgWork ,
        BYTE * _pSrcY = NULL ,
        int _thr_num = 0 ,
        void (* _SetFrame)( __m128i& ,  __m128i& , __m128i * ) = NULL
        ) :
        pW           ( _pW           ) ,
        wSpan        ( _wSpan        ) ,
        tSpan        ( _tSpan        ) ,
        SelfWeight   ( _SelfWeight   ) ,
        AngleWeight  ( _AngleWeight  ) ,
        Threads      ( _Threads      ) ,
        SrcYPitch    ( _SrcYPitch    ) ,
        Height       ( _Height       ) ,
        Width        ( _Width        ) ,
        CacheLSpan   ( _CacheLSpan   ) ,
        CacheLOffset ( _CacheLOffset ) ,
        Y_FrameCache ( _Y_FrameCache ) ,
        V_FrameCache ( _V_FrameCache ) ,
        H_FrameCache ( _H_FrameCache ) ,
        AvgWork      ( _AvgWork      ) ,
        pSrcY        ( _pSrcY        ) ,
        thr_num      ( _thr_num      ) ,
        IsYV12       ( _IsYV12       ) ,
        SetFrame     ( _SetFrame     )
    {
    }
} THREAD_PARAM2 ;

//==============================================================================
// PNLM2
//==============================================================================
class PNLM2 : public GenericVideoFilter
{
protected:
    const int Height ;
    const int Width ;
    const int Strength ;
    const int SelfWeight ;
    const int AngleWeight ;
    const int wSpan ;
    const int tSpan ;
    unsigned __int8 * pW ;
    const int Threads ;
    __int16 ** Y_FrameCache ;
    __int16 ** V_FrameCache ;
    __int16 ** H_FrameCache ;
    __int16 * AvgWork ;
    int PreFrameNum ;
    int SrcYPitch ;
    int SrcWidth ;
    int CacheLSpan ;
    int CacheLOffset ;
    DWORD (WINAPI* ThreadFunc) ( LPVOID ) ;
    void (* SetCacheFrame) ( int cache_idx , int frame_num , IScriptEnvironment* env , PClip child , THREAD_PARAM2& p ) ;
    void (* SetFrame) ( __m128i& sumY ,  __m128i& sumC , __m128i * d ) ;

public:
	PNLM2 (PClip _child, int strength, int wspan, int tspan, int selfweight, int angleweight, int _threads, int opt, IScriptEnvironment* env);
	~PNLM2 ();
    PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) ;
};
