// $Date:: 2010-02-13 22:16:09 +0900#$
// $Rev: 56 $


#include "PNLM.h"
#include "PNLM2.h"

/**************************************************************************************************/
/* Global                                                                                         */
/**************************************************************************************************/
//==============================================================================
// Create_PNLM
//==============================================================================
AVSValue __cdecl Create_PNLM(AVSValue args, void* user_data, IScriptEnvironment* env)
{
    PClip c = args[0].AsClip() ;
    if ( c->GetVideoInfo ().IsYV12 () || c->GetVideoInfo ().IsYUY2 () )
        return new PNLM(c, args[1].AsInt(44), args[2].AsInt(1), args[3].AsInt(1), args[4].AsInt(1) ,args[5].AsInt(0), env);

    env->ThrowError("PNLM: Requires YUY2/YV12 input");
    return NULL ;
}

//==============================================================================
// Create_PNLM2
//==============================================================================
AVSValue __cdecl Create_PNLM2(AVSValue args, void* user_data, IScriptEnvironment* env)
{
    PClip c = args[0].AsClip() ;
    if ( c->GetVideoInfo ().IsYV12 () || c->GetVideoInfo ().IsYUY2 () )
        return new PNLM2(c, args[1].AsInt(52), args[2].AsInt(2), args[3].AsInt(0), args[4].AsInt(0), args[5].AsInt(9), args[6].AsInt(1) ,args[7].AsInt(0), env);

    env->ThrowError("PNLM2: Requires YUY2/YV12 input");
    return NULL ;
}

//==============================================================================
// AvisynthPluginInit2
//==============================================================================
extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env)
{
    env->AddFunction("PNLM", "c[strength]i[wspan]i[tspan]i[threads]i[opt]i", Create_PNLM, 0);
    env->AddFunction("PNLM2", "c[strength]i[wspan]i[tspan]i[selfw]i[angw]i[threads]i[opt]i", Create_PNLM2, 0);
    return "PNLM ver 0.9";
}
